//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  IDE  [c[] ɍڂǉ
//  ̍ڂItH[\
//
//-----------------------------------------------------------------------------
//
//  2020N1108 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plPackageListDlg;

interface

// Register 葱 interface Œ`ȂƎsȂ
procedure Register;

implementation

uses
  ToolsAPI,
  Vcl.Dialogs,
  Vcl.Menus,
  System.AnsiStrings,
  System.SysUtils,
  plPackageListForm;

 var
   FAddItem : TMenuItem;

//-----------------------------------------------------------------------------
//  [c[] ɍڂǉECU[hNX̒`
//  IOTAWizard C^[tFCXgp
//
//  p IOTAWizard ɂȉ̃\bh͕KKv 
//  GetIDString, GetNamem, GetState, Execute
//-----------------------------------------------------------------------------
type
  TIDEPackageListDlgWizard = class(TNotifierObject,IOTAWizard)
    function GetIDString: string;
    function GetName: string;
    function GetState: TWizardState;
    procedure Execute;
    constructor Create;
    destructor Destroy; override;
    procedure OnItemClickEvent(Sender: TObject);
  end;

//-----------------------------------------------------------------------------
//  IDE ECU[hʂ邽߂̃j[NȖO̐ݒ
//-----------------------------------------------------------------------------
function TIDEPackageListDlgWizard.GetIDString: string;
begin
  Result := 'TIDEPackageListDlgWizard.1.0';
end;

//-----------------------------------------------------------------------------
//  [U[`̃ECU[h̔Cӂ̖O̐ݒ
//-----------------------------------------------------------------------------
function TIDEPackageListDlgWizard.GetName: string;
begin
  Result := 'Delphi IDE PackageList Dialog';
end;

//-----------------------------------------------------------------------------
//  j[ڂ̏Ԃ̐ݒ (LCȂ)
//-----------------------------------------------------------------------------
function TIDEPackageListDlgWizard.GetState: TWizardState;
begin
  Result := [wsEnabled];
end;

//-----------------------------------------------------------------------------
//  j[ڂIꂽɎs郁\bh
//  {Tvł͒ǉڂ OnClick Cxgŏ̂ŎgpȂ
//  gpȂĂp IOTAWizard C^[tFCXɂ̂ŎKv
//-----------------------------------------------------------------------------
procedure TIDEPackageListDlgWizard.Execute;
begin
//
end;

//-----------------------------------------------------------------------------
//  NX̃RXgN^
//  [c[] j[ɐVKɍڂǉ
//
//  uses ɈȉKv
//  Vcl.Menus,
//  System.AnsiStrings,
//  System.SysUtils;
//-----------------------------------------------------------------------------
constructor TIDEPackageListDlgWizard.Create;
var
   LIDESrv   : INTAServices;
   LToolMenu : TMenuItem;
   LIndex    : Integer;
begin
{}
  // IDE ̃IuWFNg擾
  // INTAServices  IDE ̖{
  LIDESrv := BorlandIDEServices as INTAServices;

  LToolMenu := nil;
  // Cj[ [c[] T
  for LIndex := 0 to LIDESrv.MainMenu.Items.Count - 1 do begin
    if AnsiSameText(LIDESrv.MainMenu.Items[LIndex].Name,'ToolsMenu') then begin
      LToolMenu := LIDESrv.MainMenu.Items[LIndex];
      Break;
    end;
  end;

  // Vڂ𐶐
  FAddItem := TMenuItem.Create(nil);

  // ڂ̊evpeB OnClick Cxgݒ
  FAddItem.Name    := 'plPackageList';
  FAddItem.Caption := 'pbP[W̗';
  FAddItem.OnClick := OnItemClickEvent;
  // [c[]  2 Ԗڂ̍ڂƂĒǉ
  LToolMenu.Insert(1, FAddItem);
end;

//-----------------------------------------------------------------------------
//  NX̃fXgN^
//  VKɍ쐬j[ڂ̃IuWFNgj
//-----------------------------------------------------------------------------
destructor TIDEPackageListDlgWizard.Destroy;
begin
  FreeAndNil(FAddItem);
  inherited;
end;

//-----------------------------------------------------------------------------
//  VKɒǉj[ڂ OnClick Cxg
//  tH[\
//-----------------------------------------------------------------------------
procedure TIDEPackageListDlgWizard.OnItemClickEvent(Sender: TObject);
begin
  Form1 := TForm1.Create(nil);
  try
    Form1.ShowModal;
  finally
    FreeAndNil(Form1);
  end;
end;

//-----------------------------------------------------------------------------
//  ECU[hNX𐶐ēo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterPackageWizard(TIDEPackageListDlgWizard.Create);
end;

end.
