//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  pbP[W̃R|[lg
//-----------------------------------------------------------------------------
//
//  2020N1108 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plPackageListCompoForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, 
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Splitter1: TSplitter;
    ListBox2: TListBox;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  ToolsAPI;

{$R *.dfm}

{ TForm1 }

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Splitter1.ResizeStyle := rsUpdate;

  ListBox1.Items.Clear;
  ListBox1.Font.Size  := 11;
  ListBox1.Font.Name  := 'Courier New';
  ListBox2.Items.Clear;
  ListBox2.Font.Size  := 11;
  ListBox2.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[\鎞̏
//  CXg[ĂpbP[W TListBox ɃXg
//
//  uses  ToolsAPI Kv
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LPkgeServices : IOTAPackageServices;
  LPackage      : IOTAPackageInfo;
  LIndex        : Integer;
begin
  ListBox1.Items.Clear;
  ListBox1.Items.BeginUpdate;

  // C^[tFCX̃IuWFNg擾
  LPkgeServices := BorlandIDEServices as IOTAPackageServices;

  for LIndex := 0 to  LPkgeServices.PackageCount - 1 do begin
    LPackage := LPkgeServices.Package[LIndex];

    // IDE ggppbP[W͏O
    if LPackage.IDEPackage then Continue;
    // spbP[WŎgp\ȃpbP[Wɂ鎞͈ȉǉ
    // if LPackage.RuntimeOnly then Continue;

    // Loaded  True łȂpbP[W Contains ̏񂪎擾łȂ
    LPackage.Loaded := True;
    ListBox1.AddItem(LPackage.Name, TObject(LIndex));
  end;

  ListBox1.Items.EndUpdate;
end;

//=============================================================================
//  ListBox1  OnClick Cxg
//  NbNpbP[W̃R|[lgʂ TListBox ɃXg
//
//  uses  ToolsAPI Kv
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
var
  LIndex        : Integer;
  LPkgIndex     : Integer;
  LPkgeServices : IOTAPackageServices;
begin
  LIndex := ListBox1.ItemIndex;
  if LIndex < 0 then Exit;

  LPkgIndex := Integer(ListBox1.Items.Objects[LIndex]);
  // C^[tFCX̃IuWFNg擾
  LPkgeServices := BorlandIDEServices as IOTAPackageServices;

  // w肵CfbNX̃pbP[W̃Rp[lgԂɎ擾
  ListBox2.Items.Clear;
  ListBox2.Items.BeginUpdate;
  for LIndex := 0 to LPkgeServices.ComponentCount[LPkgIndex] - 1 do begin
    ListBox2.Items.Add(LPkgeServices.GetComponentName(LPkgIndex, LIndex));
  end;
  ListBox2.Items.EndUpdate;
end;

end.
