//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  pbP[W̗񋓂ƊepbP[W̏擾
//-----------------------------------------------------------------------------
//
//  2020N1108 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plPackageListInfoForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, 
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,  ToolsAPI,
  Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    TreeView1: TTreeView;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure EachPackageInfo(APackage: IOTAPackageInfo; ATVItems: TTreeNodes);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  TreeView1.Items.Clear;
  TreeView1.Font.Size  := 11;
  TreeView1.Font.Name  := 'Courier New';
end;

//=============================================================================
//  tH[\鎞̏
//  CXg[ĂpbP[W
//  񋓂epbP[W̏擾ăc[\
//
//  uses  ToolsAPI Kv
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LPkgeServices : IOTAPackageServices;
  LPackage      : IOTAPackageInfo;
  LIndex        : Integer;
begin
  TreeView1.Items.Clear;
  TreeView1.Items.BeginUpdate;

  // C^[tFCX̃IuWFNg擾
  LPkgeServices := BorlandIDEServices as IOTAPackageServices;
  
  for LIndex := 0 to  LPkgeServices.PackageCount - 1 do begin
    LPackage := LPkgeServices.Package[LIndex];

    // IDE ggppbP[W͏O
    if LPackage.IDEPackage then Continue;
    // spbP[WŎgp\ȃpbP[Wɂ鎞͈ȉǉ
    // if LPackage.RuntimeOnly then Continue;

    // Loaded  True łȂpbP[W Contains ̏񂪎擾łȂ
    LPackage.Loaded := True;
    EachPackageInfo(LPackage, TreeView1.Items);
  end;

  TreeView1.Items.EndUpdate;
end;

//-----------------------------------------------------------------------------
//  Ŏw肷pbP[W̏ TTreeView ɕ\
//
//  uses  ToolsAPI Kv
//-----------------------------------------------------------------------------
procedure TForm1.EachPackageInfo(APackage: IOTAPackageInfo; ATVItems: TTreeNodes);
var
  LStrList  : TStringList;
  LRootNode : TTreeNode;
  LContNode : TTreeNode;
  LReqNode  : TTreeNode;
  LIndex    : Integer;
begin
  LStrList := TStringList.Create;
  try
    // [gm[h̓pbP[W
    LRootNode := ATVItems.Add(nil, APackage.Name);

    // Contains ̃Xg擾Ďqm[hƂĒǉ
    APackage.GetContainsList(LStrList);
    LContNode := ATVItems.AddChild(LRootNode, 'Contains');
    for LIndex := 0 to LStrList.Count - 1 do begin
      ATVItems.AddChild(LContNode, LStrList[LIndex]);
    end;

    // Requires ̃Xg擾Ďqm[hƂĒǉ
    APackage.GetRequiresList(LStrList);
    LReqNode := ATVItems.AddChild(LRootNode, 'Requires');
    for LIndex := 0 to LStrList.Count - 1 do begin
      ATVItems.AddChild(LReqNode, LStrList[LIndex]);
    end;

    // ̑̏ǉ
    if APackage.RuntimeOnly then
      ATVItems.AddChild(LRootNode, 'RunTimeOnly');
    if APackage.DesigntimeOnly then
      ATVItems.AddChild(LRootNode, 'DesigntimeOnly');

    // pbP[W̐eLXgǉ  
    ATVItems.AddChild(LRootNode, APackage.Description);
  finally
    FreeAndNil(LStrList);
  end;
end;

end.
